#!/bin/sh

MACOSX=`uname -a | grep Darwin`
if [ -z "$PROCESSOR" ]; then PROCESSOR=i386; fi

PROF_CMD=-Xrunprof:
PROF_MODE=listen
Parse() {
  while [ -n "$1" ]; do
    case $1 in
      -suspend|suspend)
        PROF_MODE=attach
      ;;
      -attach|attach)
        PROF_MODE=net
        if [ -z "$PROF_PORT" ]; then PROF_PORT=localhost:5115; fi
      ;;
      -port|port)
        PROF_PORT=$2
        shift
      ;;
      -jvmpi|jvmpi)
        PROF_CMD=-Xrunprof:
      ;;
      -jvmti|jvmti)
        PROF_CMD=-agentlib:proft=
      ;;
      -jdk1.6|jdk1.6)
        PROF_CMD=-agentlib:proft=
      ;;
      -jdk1.7|jdk1.7)
        PROF_CMD=-agentlib:proft=
      ;;
    esac
    shift
  done
}

Parse $EXTARGS

if [ -z "$PROF_PORT" ]; then PROF_PORT=5115; fi
if [ "$VM_VERSION" = "16" ] || [ "$VM_VERSION" = "17" ]; then PROF_CMD=-agentlib:proft=; fi
export PROF_ARGS="$PROF_MODE=$PROF_PORT"
export AGENT_PATH="$MBS_ROOT/lib/mbprofiler-agent/runtimes/$OSNAME/$PROCESSOR"
if [ -z "$MACOSX" ]; then
  export LD_LIBRARY_PATH="$AGENT_PATH:$LD_LIBRARY_PATH"
else
  export DYLD_LIBRARY_PATH="$AGENT_PATH:$DYLD_LIBRARY_PATH"
  if [ "$PROCESSOR" = "i386" ]; then
    export VM_ARGS="$VM_ARGS -d32"
  else
    export VM_ARGS="$VM_ARGS -d64"
  fi
fi
export EXTPRS="$EXTPRS;../profiler.prs"
export EXTRA_CP="$EXTRA_CP:$MBS_ROOT/lib/mbprofiler-agent/profiler-api.jar"
export PROF_BCM_PATH=$MBS_ROOT/lib/mbprofiler-agent/profiler-bcm.jar
