#!/bin/sh
#########################################################################################
# 1.2.2
# Correct some misspell on local variables that didn't have any consequence but wasn't
# easy on the eye. Suppress old unsued WriteLog function
#
# 1.2.3
# Test for PFail signal to avoid bad detection 
#########################################################################################

#########################################################################################
# Local variables defined
#########################################################################################

source /etc/gpio/GPIO_common

CAPGOOD_SCRIPT_VERSION="1.2.3"
GPIO_CAPGOOD_SCRIPT_INITIALS="[GCG]"

#########################################################################################
#########################################################################################
# Script beginning
#########################################################################################

#########################################################################################
# This script is called by a pollgpio function with the value of the gpio in entry
#
# Order of arguments
# $1 gpio value
#
# This script must update the content of a real file with the value given in entry
# The updating process must produce a MODIFY event which will be catched by the 
# application software using a watchservice. Therefore, the file is deleted before being 
# created again otherwise each overwritte of the file will produce 2 MODIFY events
# instead of the only one expected.

PFAIL=`cat /tmp/sys/class/gpio/gpio29/value`

if [ "$PFAIL" -eq "$1" ]
then
	LogUpdate "Wrong situation PFAIL $PFAIL CAPGOOD $CAPGOOD" 
else
	LogUpdate "----------------------------- $(basename "$0") v$CAPGOOD_SCRIPT_VERSION started"

	MakesGpioRealPathAvailable $CAP_DIR

	RemoveRealGpioFile $CAP_DIR				# Remove the file before writing will produce a DELETE event
	SetRealGpioValue $CAP_DIR $1			# Write value will produce a MODIFY

	LogUpdate "----------------------------- $(basename "$0") v$CAPGOOD_SCRIPT_VERSION ended"
fi