#!/bin/sh
#
# 1.2.2
# Correct log msg that was not correctly quoted

#########################################################################################
# Local variables defined
#########################################################################################

source /etc/gpio/GPIO_common

GPIO_POE_OK_SCRIPT_VERSION="1.2.2"
GPIO_POE_OK_SCRIPT_INITIALS="[GPO]"

#########################################################################################
# Fonctions
#########################################################################################

###########################################################################################
# Function that add the initials of the script to each message that will be logged.
# That makes the reading of the logs unambiguous

WriteLog() {
	LogUpdate "$GPIO_POE_OK_SCRIPT_INITIALS : $1" $2 $3
}


#########################################################################################
#########################################################################################
# Script beginning
#########################################################################################

#########################################################################################
# This script is called by a pollgpio function with the value of the gpio in entry
#
# Order of arguments
# $1 gpio value
#
# This script must update the content of a real file with the value given in entry
# The updating process must produce a MODIFY event which will be catched by the 
# application software using a watchservice. Therefore, the file is deleted before being 
# created again otherwise each overwritte of the file will produce 2 MODIFY events
# instead of the only one expected.

LogUpdate "----------------------------- $(basename $0) v$GPIO_POE_OK_SCRIPT_VERSION started"

MakesGpioRealPathAvailable $POE_DIR

RemoveRealGpioFile $POE_DIR																											# Remove the file before writing will produce a DELETE event
SetRealGpioValue $POE_DIR $1																										# Write value will produce a MODIFY

LogUpdate "----------------------------- $(basename $0) v$GPIO_POE_OK_SCRIPT_VERSION ended"
