#!/bin/sh

# Network Configuration Script to be called on MMI Switch Changes (Online/Offline, Auto/Router)
# 	Parameter : New Mode (Normal, Installer, intercom, recovery) 
#	Edited by D.Burke

NETCONFIG_VERSION=1.0

[ -z "$1" ] && echo "Error: netconfig requires a parameter for new mode" && exit 1

OLDMODE=`cat /etc/network/mode`

echo "netconfig.sh $1 ($OLDMODE)" > /dev/console 

#printenv > /dev/console

if [ $1 == $OLDMODE ]; then
	echo "netconfig.sh mode unchanged!" > /dev/console
	exit 1
fi


/etc/init.d/S40network stop
/etc/init.d/S45ifplugd stop

# [ -x /var/run/udhcpc.eth0.pid ] && kill /var/run/udhcpc.eth0.pid
# [ -x /var/run/udhcpc.eth1.pid ] && kill /var/run/udhcpc.eth1.pid
# [ -x /var/run/udhcpc.br0.pid ] && kill /var/run/udhcpc.br0.pid
# [ -x /var/run/udhcpd.pid ] && kill /var/run/udhcpd.pid

# kill `pidof udhcpd` 
# echo 0 > /proc/sys/net/ipv4/ip_forward

echo $1 > /etc/network/mode

case $1 in
	normal)
		echo "netconfig.sh normal...." > /dev/console
		cp /etc/network/interfaces-normal /etc/network/interfaces
		/etc/init.d/S40network start
		/etc/init.d/S45ifplugd start		
		;;
	installer)
		echo "netconfig.sh installer...." > /dev/console
		cp /etc/network/interfaces-installer /etc/network/interfaces		
        /etc/init.d/S40network start
        /etc/init.d/S45ifplugd start
		# udhcpd /etc/udhcpd-installer.conf
 		;;
	intercom)
		echo "netconfig.sh intercom...." > /dev/console
		cp /etc/network/interfaces-intercom /etc/network/interfaces		
        /etc/init.d/S40network start
        /etc/init.d/S45ifplugd start
		# udhcpd /etc/udhcpd-intercom.conf
		# echo 1 > /proc/sys/net/ipv4/ip_forward
 		;;
	recovery)
		echo "netconfig.sh recovery...." > /dev/console
		cp /etc/network/interfaces-recovery /etc/network/interfaces		
        /etc/init.d/S40network start
        /etc/init.d/S45ifplugd start
 		;;
	emss)
		echo "netconfig.sh emss/hbs...." > /dev/console
		cp /etc/network/interfaces-emss /etc/network/interfaces		
        /etc/init.d/S40network start
        /etc/init.d/S45ifplugd start
 		;;
	stop)
		echo "netconfig.sh stop...." > /dev/console
		echo "" > /etc/network/interfaces
		
		;;
esac


exit 0 
