#!/bin/sh

##########################################################################
# Variables defined
##########################################################################

LOG_FILE=/dev/console

##########################################################################
# Process start
##########################################################################

LogDate=`date +%Y/%m/%d-%H:%M:%S`

if [ "${ACTION}" = "add" ]; then
	if [ "${SUBSYSTEM}" = "block" ] ; then
		if [ "${DEVTYPE}" = "partition" ] ; then

			# Check if device is mounted in media
			MediaIsMounted=`ls /media/ | grep ${dir_name} | wc -l`
			
			if [ $MediaIsMounted -eq 1 ]; then
				# Launch update script and exit
				/usr/local/bin/update_from_directory.sh /media/${dir_name}&
			else
				echo "$LogDate : ${DEVNAME} is not mounted in /media/${dir_name}" > $LOG_FILE
			fi

		fi
	fi
elif [ "${ACTION}" = "remove" ] ; then
	if [ "${SUBSYSTEM}" = "block" ] ; then
		if [ "${DEVTYPE}" = "partition" ] ; then
			
			# Check if BSP Update is OK and then reboot
			if [ -f /tmp/BSP_UPDATE_OK ]; then
				echo "$LogDate : System will reboot, please wait..." > $LOG_FILE
				sleep 1
				reboot
			fi
		
		fi
	fi
fi

exit 0
