/*
 * prof_api.h
 *
 * Copyright (c) ProSyst Software
 * All rights reserved
 *
 * @author  Ivo Karabashev
 */

#ifndef _PROF_API_H
#define _PROF_API_H

#include <jni.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifdef _JVMPI
  struct prof_data;

  void register_api(struct prof_data* dptr, JNIEnv* env);
  JNIEXPORT jint JNICALL JVM_OnLoad(JavaVM* vm, char* options, void* reserved);
  JNIEXPORT jint JNICALL JVM_OnUnload(JavaVM* vm, char* options, void* reserved);
#else /* _JVMPI */
  JNIEXPORT jint JNICALL Agent_OnLoad(JavaVM* vm, char* options, void* reserved);
  JNIEXPORT void JNICALL Agent_OnUnload(JavaVM* vm);
#endif /* _JVMPI */

  JNIEXPORT jint JNICALL prof_connect(const char* host, unsigned short port);
  JNIEXPORT jint JNICALL prof_execute_cmd(int cmd, int param1, int param2, int param3);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* !_PROF_API_H */
