(function ($, ns) {
	ns.dataservice = function () {
		var
			_parseErrorsForAccordion = function (errors) {
				var
					 i = 0,
					 html = "<div>",
					 prop = null;
				
				for (i = 0; i < errors.length; i++) {
					html += '<h3><a href="#">' + errors[i].Message + '</a></h3><div>';
					for (prop in errors[i]) {
						if (prop === "Message") {
							continue;
						}
						
						html += '<p><strong>' + prop + ': </strong><span>' + errors[i][prop] + '</span></p>';
					}
					html += "</div>";
				}
				
				html += "</div>";
				
				return html;
			},
			
			getURL = function (path) {
				return window.location.protocol + "//" + window.location.host + "/system/configtree/" + path;
			},
			
			getConfigurableRoot = function (configurableName, callback) {
			    $.ajax({
					url: getURL("getConfig"),
					async: false,
					type: 'POST',
					dataType: 'json',
					data: {
						type: configurableName
					},
					success: callback,
					error: function (jqXHR, textStatus, errorThrown) {
						ns.utils.logError("CUSTOM:\n" + "getConfigurableRoot returned error\n" + errorThrown);
					}
				});
			},
			
			getConfigurableTypes = function (callback) {				
			    $.ajax({
				  url: getURL("getConfigurableTypes"),
				  async: false,
				  dataType: 'json',
				  success: callback,
					error: function (jqXHR, textStatus, errorThrown) {
						ns.utils.logError("CUSTOM:\n" + "getConfigurableTypes returned error\n" + errorThrown);
					}
				});
			},

			save = function (data, callback, nodeType) {
			    var methodName = "setConfig";

			    if (nodeType === ns.config.nodeTypes.mapProperty) {
			        methodName = "setMap";
			    }

			    $.ajax({
					url: getURL(methodName),
					async: false,
					type: 'POST',
					dataType: 'json',
					data: data,
					success: function (data, textStatus, jqXHR) {
						var 
							i = 0,
							html = "",
							prop = null;

						if (data.State === 1) {
							callback({data: data, textStatus: textStatus, jqXHR: jqXHR});
							return;
						} else if (data.Errors) {
							html += _parseErrorsForAccordion(data.Errors);
							dialogs.details.open(html, "Set Config - State: " +  ns.utils.successStateCodesMap[data.State+""]);
						} else {
							html += '<h1>State: ' + ns.utils.successStateCodesMap[data.State+""] + '</h1>';
							dialogs.notification.open(html, dialogs.notification.types.error, "Save Failed");
						}						
					},
					error: function (jqXHR, textStatus, errorThrown) {
						ns.utils.logError("CUSTOM:\n" + "setConfig returned error\n" + errorThrown);
					}
				});
			};
			
		return {
			getConfigurableTypes: getConfigurableTypes,
			getConfigurableRoot: getConfigurableRoot,
			getURL: getURL,
			save: save
		};
	}();
}($, window.configTree = window.configTree || {}))