(function ($, ko, ns) {
	ns.utils = ns.utils || {};
	var utils = ns.utils;

	utils.__extends = function (d, b) {
	    function __() { this.constructor = d; }
	    __.prototype = b.prototype;
	    d.prototype = new __();
	};

	utils.logError = function (message) {
		if (console && console.error) {
			console.error(message);
		}
	};
	
	utils.successStateCodesMap = {
		"0": "FAILED",
		"1": "SUCCESS", 
		"2": "NOT SUPPORTED",
		"3": "WARNING"
	};
	
	utils.configNodeComparator = function (a, b) {
	    var
            nodeNameA = a.nodeName(),
            nodeNameB = b.nodeName();

	    if (a.configNodeType === b.configNodeType) {
	        if (nodeNameA > nodeNameB) {
	            return 1;
	        } else if (nodeNameA < nodeNameB) {
	            return -1;
	        } else {
	            return 0;
	        }
	    } else if (a.configNodeType === ns.config.nodeTypes.node) {
	        return -1;
	    } else if (b.configNodeType === ns.config.nodeTypes.node) {
	        return 1;
	    }

	    return 0;
	};

	utils.parseImportResponse = function (response) {
		var 
			i = 0,
			html = "<div>",
			j = 0,
			prop = null;

		for (i = 0; i < response.length; i++) {
			html += '<h3><a href="#">' + response[i].ConfigType + ': ' + ns.utils.successStateCodesMap[response[i].State+""] + '</a></h3>';
			html += "<div>";
			if (response[i].Errors) {
				html += '<ul class="errors-list">';
				for (j = 0; j < response[i].Errors.length; j++) {
					html += '<li class="error-item"><p><strong>Message: </strong><span>' + response[i].Errors[j].Message + "</span></p>";
					for (prop in response[i].Errors[j]) {
						if (prop === "Message") {
							continue;
						}
						
						html += "<p><strong>" + prop + ": </strong><span>" + response[i].Errors[j][prop] + "</span></p>";
					}
					html += "</li>";
				}
				html += "</ul>";
			}
			html += "</div>";
		}		
		
		html += "</div>";
		return html;
	};
	
} ($, ko, window.configTree = window.configTree || {}))