(function ($, ko, ns) {
	ns.importConfigNodeViewModel = function () {
		var
			// public properties
			form = {
				method: "POST",
				target: "importNodeFrame",
				action: ns.dataservice.getURL("importConfig"),
				enctype: "multipart/form-data"
			},
			exportFormatSelect = {
				name: "format",
				formats: ["XML", "BIN"]
			},
			configurableTypesBlankText = "";
			selectedConfigurableType = ko.observable(""),
			selectedConfigNodePath = ko.observable().publishOn("pathChanged", false),
			importAsRoot = ko.observable(false),
			
			// private properties
			
			_path = ko.observable().subscribeTo("pathChanged", true),
			_hasMadeRequest = false, // sync, wrong when async
			
			// public methods
			
			// implementation is provided in the VM(configTreeVM) that uses this VM(importConfigNodeViewModel)
			refresh = function () {},
			
			frameLoadedCallback = function (vm, event) {
				if (!_hasMadeRequest) {
					return;
				}
				_hasMadeRequest = false;

				if ($("#importNodeFrame")[0].contentWindow) {
				    vm.refresh($($("#importNodeFrame")[0].contentWindow.document.body).text());
				}
			},
			
			// public commands
			
			submitFormCommand = function (form) {
			    var fileInput = $(form).find('input[type="file"]')[0];

			    if (!!(fileInput.files && fileInput.files.length > 0) || !!(fileInput.value && fileInput.value.length)) {
			    //if ($(form).find('input[type="file"]')[0].files.length > 0) {
			        if (importAsRoot() && _path() === "") {
						selectedConfigNodePath(null);
					} else if (_path() !== selectedConfigNodePath()) {
						selectedConfigNodePath(_path());
					}
					_hasMadeRequest = true;
					return true;
				}	
				
				return false;
			},
			
			submitButtonCommand = function (vm, event) {
				if (typeof selectedConfigurableType() !== "string" || selectedConfigurableType() === configurableTypesBlankText) {
					if (event) {
						event.stopPropagation();
					} else {
						window.event.cancelBubble = true
					}
					
					return false;
				}
				
				return true;
			};
		
		return {
			form: form,
			exportFormatSelect: exportFormatSelect,
			selectedConfigurableType: selectedConfigurableType,
			selectedConfigNodePath: selectedConfigNodePath,
			importAsRoot: importAsRoot,
			submitButtonCommand: submitButtonCommand,
			submitFormCommand: submitFormCommand,
			frameLoadedCallback: frameLoadedCallback,
			refresh: refresh
		};
	}();
}($, ko, window.configTree = window.configTree || {}))