(function ($, ko, ns) {
    ns.importPackViewModel = function () {
        var
			hasMadeRequest = false,

			form = {
			    method: "POST",
			    target: "importPackFrame",
			    action: ns.dataservice.getURL("importzip"),
			    enctype: "multipart/form-data"
			},

			importFormatSelect = {
			    name: "format",
			    formats: ["XML", "BIN"]
			},

			importAllCheckbox = {
			    name: "all",
			    value: "all",
			    checked: ko.observable(true)
			},

			selectedConfigurableType = ko.observable(""),

			configurableTypeBaseName = "config",

			configurableTypes = ko.observableArray(),

			updateConfigurableTypes = function (configurableTypes) {
			    configurableTypes(configurableTypes);
			},

			submitFormCommand = function (form) {
			    hasMadeRequest = true;
			    var isValid = true,
                    fileInput = $(form).find('input[type="file"]')[0];
                    
			    if (!!(fileInput.files && fileInput.files.length === 0) || !!(fileInput.value && !fileInput.value.length)) {
			        isValid = false;
			    }

			    if (!importAllCheckbox.checked() && $(form).find('input[type="checkbox"]').filter(":checked").length === 0) {
			        isValid = isValid && false;
			    }

			    return isValid;
			},

			refresh = function () { },

			frameLoadedCommand = function (vm, event) {
			    if (!hasMadeRequest) {
			        return;
			    }
			    hasMadeRequest = false;

			    if ($("#importPackFrame")[0].contentWindow) {
			        vm.refresh($($("#importPackFrame")[0].contentWindow.document.body).text());
			    }
			};

        importAllCheckbox.checked.subscribe(function (newValue) {
            $("#configs").find("input").filter(":checkbox").each(function (index, element) {
                $(element).attr("checked", newValue);
            });
        });

        return {
            form: form,
            importFormatSelect: importFormatSelect,
            selectedConfigurableType: selectedConfigurableType,
            importAllCheckbox: importAllCheckbox,
            configurableTypeBaseName: configurableTypeBaseName,
            configurableTypes: configurableTypes,
            submitFormCommand: submitFormCommand,
            frameLoadedCommand: frameLoadedCommand,
            refresh: refresh
        };
    }();
}($, ko, window.configTree = window.configTree || {}));