(function (ns) {
    ns.GridViewColumnHeader = function (caption, sortOptions) {
        var _sortIconClasses;

        this.caption = caption;
        this.isSortable = !!sortOptions;

        if (this.isSortable) {
            _sortIconClasses = sortOptions.iconClasses;
            this.sortKey = sortOptions.key;
            this.isSorted = ko.observable(!!sortOptions.isSorted);
            this.isSorted.isAscending = ko.observable(!!sortOptions.isAscending);
            this.resetSortState = function (isAscendingDefault) {
                this.isSorted(false);
                this.isSorted.isAscending(typeof isAscendingDefault !== "boolean" ? true : isAscendingDefault);
            };
        }

        this.classes = ko.computed(function () {
            var _class ="";//_classes

            if (!_sortIconClasses) return _class;
            if (!this.isSorted()) {
                _class += " " + _sortIconClasses.notSorted;
            } else if (this.isSorted.isAscending()) {
                _class += " " + _sortIconClasses.descending;
            } else {
                _class += " " + _sortIconClasses.ascending;
            }

            return _class;
        }, this);
    };
})( window.knx = window.knx || {} );