(function (ns) {
    ns.vm = function () {
        var gridViewViewModel = ko.observable(),
        	operationsContainer = ko.observable(),
        	driversContainer = {
        		driversList: ko.observableArray(),
        		driverIdCurrent: ko.observable(),
        		driverReload: _onReloadClick,
        		driverReloadTitle: i18n.knxDriver.reloadBtn,
        		driverIdLabel: i18n.knxDriver.label
        	};
       	getServices();
       	driversContainer.driverIdCurrent.subscribe(function(value) {
       		if(value){
       			getLogItemsFromServer( value );
       		}
       		  
       	});

        function getServices() {
    		ns.dataservice.getDataLinkServices().done(function (result) {
			    var driversCollection = [];
			    if(!result) return;
				$.each(result, function(idx, el) {
					driversCollection.push(el);
				});
				
				driversContainer.driversList( driversCollection );
			}).fail(function (error) {
			    ns.modalDialog.notification.open(error.code, error.message, ns.modalDialog.notification.types.error);
			});
        };
		
        function activate() {
        	driversContainer.driverIdCurrent(driversContainer.driversList()[0]);
        	getLogItemsFromServer( driversContainer.driverIdCurrent() );	
        };

        function getLogItemsFromServer(driverIdVal) {
            ns.dataservice.readAllFrames(driverIdVal).done(function (result) {
                gridViewViewModel().update(result);
            }).fail(function (error) {
                ns.modalDialog.notification.open(error.code, error.message, ns.modalDialog.notification.types.error);
            });
        };
        
        function _onReloadClick(vm,event) {
        	var sourceElement = event.source || event.srcElement || event.target,
                sourceVM = ko.dataFor(sourceElement);
                if($(sourceElement).attr('id')==='reload') {
                	getLogItemsFromServer( driversContainer.driverIdCurrent() );
                }
        };

        function onPerformOperationClick (driverid, destination, value, readVaue, dptType) {
        	if (readVaue == dptType) {  
                    ns.dataservice.readGroupValue(driverid || "", destination).done(function (result) {
                    }).fail(function (error) {
                        ns.modalDialog.notification.open(error.code, error.message, ns.modalDialog.notification.types.error);
                    });
                } else if($.isArray(value)) {    
                        ns.dataservice.writeGroupValueLong(driverid || "", destination, value).done(function (result) {
                        }).fail(function (error) {
                            ns.modalDialog.notification.open(error.code, error.message, ns.modalDialog.notification.types.error);
                        });
                } else {
                        ns.dataservice.writeGroupValueShort(driverid || "", destination, value).done(function (result) {
                        }).fail(function (error) {
                            ns.modalDialog.notification.open(error.code, error.message, ns.modalDialog.notification.types.error);
                        });
                }
                setTimeout(function() {
                    ns.vm.getLogItemsFromServer( driverid );
                }, 500);
        };

        return { 
            gridViewViewModel: gridViewViewModel,
            operationsContainer: operationsContainer,
            driversContainer: driversContainer,
            activate: activate,
            getLogItemsFromServer: getLogItemsFromServer,
            onPerformOperationClick: onPerformOperationClick
        };
    }();
})(window.knx = window.knx || {});