$.fn.dataTableExt.oApi.fnLengthChange = function (oOptions, iScreen)
{
    oOptions._iDisplayLength = iScreen;
    oOptions.oApi._fnCalculateEnd(oOptions);
     
    /* Check if have enough space for rows (from down to up) */
    if (oOptions._iDisplayEnd == oOptions.aiDisplay.length) {
        oOptions._iDisplayStart = oOptions._iDisplayEnd - oOptions._iDisplayLength;
        if (oOptions._iDisplayStart < 0) {
            oOptions._iDisplayStart = 0;
        }
    }
     
    if (oOptions._iDisplayLength == -1) {
        oOptions._iDisplayStart = 0;
    }
     
    oOptions.oApi._fnDraw(oOptions);
     
    if (oOptions.aanFeatures.l) {
       $('.itemsPerPage', oOptions.aanFeatures.l).val(iScreen);
    }
}

function doFilter(filter) {
	var oTable = $('#tc_runs_table').dataTable();
  	var oSettings = oTable.fnSettings();
  	if (typeof filter.text !== "undefined") {
	  	oSettings.aoPreSearchCols[0].sSearch = filter.text;
	  	oSettings.aoPreSearchCols[1].sSearch = filter.text;
  	}
  	if (typeof filter.status !== "undefined") {
  		oSettings.aoPreSearchCols[2].sSearch = filter.status;
  	}
  	if (typeof filter.text !== "undefined" || typeof filter.status !== "undefined") {
    	oTable.fnDraw();
    }
}


$.fn.dataTableExt.oApi.fnProcessingIndicator = function ( oOptions, onoff ) {
    if (typeof(onoff) == 'undefined') {
        onoff=true;
    }
    this.oApi._fnProcessingDisplay(oOptions, onoff);
}

$(document).ready(function() {
	// install user interaction handlers
	
    $('.reloadButton').click(function() {
        if ($(this).hasClass('ui-state-disabled')){
   	     	return;
   	    }
  		var oTable = $('#tc_runs_table').dataTable();
    	oTable.fnDraw();
		return false;
	});
	
    $('.filterApply').click(function() {
   	    if ($(this).hasClass('ui-state-disabled')){
   	     	return;
   	    }
	    var v = $(this).parent().find('input.filter').val();
	    $('input.filter').val(v);
        doFilter({
    		text:v
        });
		return false;
	});
	
	$('.filterClear').click(function() {
	    if ($(this).hasClass('ui-state-disabled')){
	     	return;
	    }
        $('input.filter').val('');
         doFilter({
    		text:''
        });
    	return false;
    }); 
	
	$('.clearButton').click(function() {
	    if ($(this).hasClass('ui-state-disabled')){
   	     	return;
   	    }
		if(confirm(nlsMessages.askForLogsClear)){
		 	var oTable = $('#tc_runs_table').dataTable();
		 	oTable.fnProcessingIndicator(true);
	    	$.ajax({
        			  url: 'tee/action.json',
        			  type: 'POST',
        			  dataType: 'json',
        			  data: {
           					"action":'clear'
        			  },
        			  success: function(result){
	        			   var oTable = $('#tc_runs_table').dataTable();
						   oTable.fnDraw();
						   if(!result.status){
						 	 alert(nlsMessages.logsCleanFailed);
						   }
        			  },
				      complete: function(){     
				       	 	var oTable = $('#tc_runs_table').dataTable();
		 					oTable.fnProcessingIndicator(false);
				      }
   	 		});
	    	
    	}
		return false;
	});
	
	$('.status').change(function () {
	    if ($(this).hasClass('ui-state-disabled')){
   	     	return;
   	    }
   	    $('select.status').val(this.value);
		doFilter({
    		status:this.value
        });
    });
	
	$('.itemsPerPage').change(function () {
	    if ($(this).hasClass('ui-state-disabled')){
   	     	return;
   	     }
		 var rowsPerPage=parseInt(this.value);
	 	 if(isNaN(rowsPerPage)){
	 	 	rowsPerPage=constants.itemsPerPage;
	 	 }
 	 	 var oTable = $('#tc_runs_table').dataTable();
    	 oTable.fnLengthChange(rowsPerPage);
     });
    
	$.fn.dataTableExt.oPagination.iFullNumbersShowPages=0;
	
	//Setup sorting classes
	$.fn.dataTableExt.oStdClasses.sSortable='ui-widget-header header';
	$.fn.dataTableExt.oStdClasses.sSortAsc='ui-widget-header header headerSortDown ui-state-focus';
	$.fn.dataTableExt.oStdClasses.sSortDesc='ui-widget-header header headerSortUp ui-state-focus';
	
	//Setup pager classes
	$.fn.dataTableExt.oStdClasses.sPageButtonActive='ui-state-enabled';
	$.fn.dataTableExt.oStdClasses.sPageButtonStaticDisabled='ui-state-disabled';
	$.fn.dataTableExt.oStdClasses.sPageFirst='icon-no-border ui-icon ui-icon-seek-first left_panel_style';
	$.fn.dataTableExt.oStdClasses.sPagePrevious='icon-no-border ui-icon ui-icon-seek-prev left_panel_style';
	$.fn.dataTableExt.oStdClasses.sPageNext='icon-no-border ui-icon ui-icon-seek-next right_panel_style';
	$.fn.dataTableExt.oStdClasses.sPageLast='icon-no-border ui-icon ui-icon-seek-end right_panel_style';
	
	$('#tc_runs_table').dataTable( {
		'sDom': 'lrt<pi>',
		'bPaginate': true,
		'bJQueryUI': false,
		'bStateSave': true,
		'sCookiePrefix': 'tee_plugin_',
		'iCookieDuration': 60*60,
		'bProcessing':true,
		'bLengthChange': false,
		'iDisplayLength': constants.itemsPerPage,
		'bFilter': true,
		'bInfo': true,
		'sPaginationType': 'full_numbers',
		'bServerSide': true,
		'sAjaxSource': 'tee/data.json',
		'oLanguage': {
      				'sEmptyTable': nlsMessages.emptyTable,
      				'sInfo': nlsMessages.info,
					'sInfoEmpty': nlsMessages.infoEmpty,
					'sProcessing': nlsMessages.loadingData
    	},
		'aoColumns': [
						{
							'mDataProp': 'projectName',
							'fnRender': function(obj) {
								if(obj.aData.location!==constants.invalidURL){
									return '<a href="'+obj.aData.location+'">'+obj.aData.projectName+'</a>';
								} else{
									return '<span>'+obj.aData.projectName+'</span>';
								}
							  }
						},
						{
							'mDataProp': 'timestamp',
							'fnRender': function(obj) {
								if(obj.aData.location!==constants.invalidURL){
									return '<a href="'+obj.aData.location+'">'+obj.aData.timestamp+'</a>';
								}else{
									return '<span>'+obj.aData.timestamp+'</span>';
								}
							}
						},
						{
							'mDataProp': 'status',
							'fnRender': function(obj) {
								if(obj.aData.location!==constants.invalidURL){
									return '<a href="'+obj.aData.location+'">'+obj.aData.status+'</a>';
								} else {
									return obj.aData.status;
								}
							}
						}
					],
		  'aaSorting': [[1,'desc']],//Setup initial sorting by timestamp
    	  'fnDrawCallback': function() {
    	        //Setup pager buttons tool-tips
      			var oSettings = $('#tc_runs_table').dataTable().fnSettings();
      			var iDisplayLength=oSettings._iDisplayLength;
      			
      			if(iDisplayLength==-1){
      				document.getElementById(oSettings.sTableId+'_paginate').style.visibility = 'hidden';
      			}else{
      			    document.getElementById(oSettings.sTableId+'_paginate').style.visibility = 'visible';
      			    
					var first_btn = document.getElementById(oSettings.sTableId+'_first');
			 		first_btn.title=nlsMessages.firstPage;
			 		
			 	    var last_btn = document.getElementById(oSettings.sTableId+'_last');
			 		last_btn.title=nlsMessages.lastPage;
			 		
			 		var prev_btn = document.getElementById(oSettings.sTableId+'_previous');
			 		if(prev_btn.className.indexOf('disabled')!=-1){
			 			 prev_btn.title=nlsMessages.previousPage;
			 		}else{
			 			var displayStart=oSettings._iDisplayStart-oSettings._iDisplayLength+1;
			 			var displayEnd=oSettings._iDisplayStart;
			 			prev_btn.title=displayStart+'...'+displayEnd;
			 		}
			 		
			 		var next_btn = document.getElementById(oSettings.sTableId+'_next');
			 		if(next_btn.className.indexOf('disabled')!=-1){
			 			 next_btn.title=nlsMessages.nextPage;
			 		}else{
			 		    var displayStart=oSettings._iDisplayStart+iDisplayLength+1;
			 			var displayEnd=displayStart+oSettings._iDisplayLength-1;
			 			if(displayEnd>oSettings.fnRecordsTotal()){
			 				displayEnd=oSettings.fnRecordsDisplay();
			 			}
			 			next_btn.title=displayStart+'...'+displayEnd;
			 		}
		 		}
		 		
		 		$('.itemsPerPage').val(oSettings._iDisplayLength+'');
		 		
    	 },
    	 'fnRowCallback': function(nRow, aData, iDisplayIndex, iDisplayIndexFull ) {
		  		//Appends jquery theme default class
		  		nRow.className=nRow.className+' ui-state-default';
		  		return nRow;
		 },
	     'fnServerData': function ( url, data, callback, settings ) {
				settings.jqXHR = $.ajax( {
					"url": url,
					"data": data,
					"success": function (json) {
						$(settings.oInstance).trigger('xhr', settings);
						callback( json );
						var summaryMsg=nlsMessages.summaryMsg;
						var summary=json.summary;
						var keys = new Array();
						for(var key in summary){
						   keys.push(key);
						}
					  if(keys.length>0){
					  summaryMsg+=': ';
						for(var i=0;i<keys.length-1;i++){
							  summaryMsg+=summary[keys[i]]+ ' '+keys[i]+', ';
						}
						var lastKey=keys[keys.length-1];
						    summaryMsg+=summary[lastKey]+ ' '+lastKey+'.';
						}
						$('.statline').html(summaryMsg);	
					},
					"dataType": "json",
					"cache": false,
					"error": function (xhr, error, thrown) {
						if ( error == "parsererror" ) {
							alert( "DataTables warning: JSON data from server could not be parsed. "+
								"This is caused by a JSON formatting error." );
						}
					}
				} );
	    }
	});
});